unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, SQLite3Conn, DB, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, DBGrids, Buttons, DBCtrls, StdCtrls, Windows;

type

  { TfrmMainForm }

  TfrmMainForm = class(TForm)
    btnEnde: TBitBtn;
    btnOpenTab: TBitBtn;
    DBGridB: TDBGrid;
    DBGridA: TDBGrid;
    DBNavigator1: TDBNavigator;
    DBNavigator2: TDBNavigator;
    dsLagerA: TDataSource;
    dsLagerB: TDataSource;
    Panel1: TPanel;
    Panel2: TPanel;
    SQLite3Connection1: TSQLite3Connection;
    SQLite3Connection2: TSQLite3Connection;
    SQLTransaction1: TSQLTransaction;
    SQLTransaction2: TSQLTransaction;
    tbLagerA: TSQLQuery;
    tbLagerB: TSQLQuery;
    tbLagerAArtikel_Nr: TStringField;
    tbLagerABestand: TLargeintField;
    tbLagerABezeichnung: TStringField;
    tbLagerAE_Preis: TFloatField;
    tbLagerAG_Preis: TFloatField;
    tbLagerAHersteller: TStringField;
    tbLagerAHersteller_Nr: TStringField;
    tbLagerAID: TLargeintField;
    tbLagerALagerort: TStringField;
    tbLagerAWarengruppe: TStringField;
    tbLagerBArtikel_Nr: TStringField;
    tbLagerBBestand: TLargeintField;
    tbLagerBBezeichnung: TStringField;
    tbLagerBE_Preis: TFloatField;
    tbLagerBG_Preis: TFloatField;
    tbLagerBHersteller: TStringField;
    tbLagerBHersteller_Nr: TStringField;
    tbLagerBID: TLargeintField;
    tbLagerBLagerort: TStringField;
    tbLagerBWarengruppe: TStringField;
    procedure btnEndeClick(Sender: TObject);
    procedure btnOpenTabClick(Sender: TObject);
    procedure CreateDatabase;
    procedure OpenDatabase;
    procedure tbLagerAAfterPost(DataSet: TDataSet);
    procedure tbLagerBCalcFields(DataSet: TDataSet);
    procedure tbLagerCalcFields(DataSet: TDataSet);

    procedure Spaltenbreite();


  private

  public

  end;

var
  frmMainForm: TfrmMainForm;

implementation

{$R *.lfm}

{ TfrmMainForm }

// Blorgbeard - http://stackoverflow.com/a/2864009/1037511
function Is64BitOS: Boolean;
type
  TIsWow64Process = function(Handle:THandle; var IsWow64 : BOOL) : BOOL; stdcall;
var
  hKernel32 : Integer;
  IsWow64Process : TIsWow64Process;
  IsWow64 : BOOL;
begin
  // we can check if the operating system is 64-bit by checking whether
  // we are running under Wow64 (we are 32-bit code). We must check if this
  // function is implemented before we call it, because some older versions
  // of kernel32.dll (eg. Windows 2000) don't know about it.
  // see http://msdn.microsoft.com/en-us/library/ms684139%28VS.85%29.aspx

  // Wir können überprüfen, ob das Betriebssystem 64-Bit ist, indem wir prüfen, ob
  // wir laufen unter Wow64 (wir sind 32-Bit-Code). Wir müssen prüfen, ob dies der Fall ist
  // Die Funktion wird implementiert, bevor wir sie aufrufen, da einige ältere Versionen
  // von kernel32.dll (zB Windows 2000) wissen nichts davon.
  // siehe http://msdn.microsoft.com/en-us/library/ms684139%28VS.85%29.aspx
  // uses Windows wird benötigt ...

  Result := False;
  hKernel32 := LoadLibrary('kernel32.dll');
  if (hKernel32 = 0) then RaiseLastOSError;
  IsWow64Process := TIsWow64Process(GetProcAddress(hkernel32, 'IsWow64Process'));
  if Assigned(IsWow64Process) then begin
    IsWow64 := False;
    if (IsWow64Process(GetCurrentProcess, IsWow64)) then begin
      Result := IsWow64;
    end
    else RaiseLastOSError;
  end;
  FreeLibrary(hKernel32);
end;



procedure TfrmMainForm.btnEndeClick(Sender: TObject);
begin
  if tbLagerA.Active = True then
    begin
      tbLagerA.Close;
      SQLite3Connection1.Connected:=False;
    end;

  if tbLagerB.Active = True then
    begin
      tbLagerB.Close;
      SQLite3Connection2.Connected:=False;
    end;

  Close;
end;

procedure TfrmMainForm.CreateDatabase;  //(Sender: TObject);
var
  s, Pfad, Filename : string;
begin

  Pfad := (ExtractFilePath(Application.ExeName) + 'DATA\');

  // Tabelle LAGERVERWALTUNG
  begin
    tbLagerA.Database := SQLite3Connection1;
    tbLagerA.SQL.Text := 'SELECT * FROM LAGERVERWALTUNG';

    Filename := Pfad + 'LAGER_' + '.db3';
    SQLite3Connection1.DatabaseName := Filename;
    SQLite3Connection1.Params.Add('foreign_keys=1');
  end;

  if Is64BitOS then showmessage('ok');
  SQLite3Connection1.Connected := False;

 // tbLagerA.Close;
  tbLagerA.Active := False;
  SQLite3Connection1.Connected := False;

  if FileExists(SQLite3Connection1.DatabaseName) then
    if not DeleteFile(pchar(SQLite3Connection1.DatabaseName)) then
    begin
      ShowMessage('kann die Datenbank-Datei nicht löschen');
      exit;
    end;

  SQLite3Connection1.Connected := True;

  s := 'CREATE TABLE LAGERVERWALTUNG(';
  s := s + ' ID INTEGER PRIMARY KEY AUTOINCREMENT,';
  s := s + ' Artikel_Nr VARCHAR(15),';
  s := s + ' Hersteller_Nr VARCHAR(15),';
  s := s + ' Hersteller VARCHAR(20),';
  s := s + ' Bezeichnung VARCHAR(40),';
  s := s + ' Warengruppe VARCHAR(30),';
  s := s + ' Bestand Integer,';
  s := s + ' Lagerort VARCHAR(15),';
  s := s + ' E_Preis REAL,';
  s := s + ' G_Preis REAL';

  s := s + ');';
  SQLite3Connection1.ExecuteDirect(s);

  SQLTransaction1.Commit;

  SQLite3Connection1.Transaction.CommitRetaining;

end;

procedure TfrmMainForm.btnOpenTabClick(Sender: TObject);
begin
  OpenDatabase;
end;

procedure TfrmMainForm.OpenDatabase;
var
  Filename, Pfad : string;
begin

  Pfad := (ExtractFilePath(Application.ExeName) + 'DATA\');

  // Tabelle Lager_A
  begin
    tbLagerA.Database := SQLite3Connection1;
    tbLagerA.SQL.Text := 'SELECT * FROM LAGERVERWALTUNG';

    Filename := Pfad + 'LAGER_A' + '.db3';
    SQLite3Connection1.DatabaseName := Filename;
    SQLite3Connection1.Params.Add('foreign_keys=1');

  if not FileExists(SQLite3Connection1.DatabaseName) then
    begin
      ShowMessage('Datenbank-Datei KategParameter "LAGERA.db3" ist nicht vorhanden');
      exit;
    end
    else
      SQLite3Connection1.Connected := True;
      SQLTransaction1.Active := True;
      tbLagerA.Open;
  end;
  tbLagerA.First;

  //-------------------------------------------------

  // Tabelle Lager_B
  begin
    tbLagerB.Database := SQLite3Connection2;
    tbLagerB.SQL.Text := 'SELECT * FROM LAGERVERWALTUNG';

    Filename := Pfad + 'LAGER_B' + '.db3';
    SQLite3Connection2.DatabaseName := Filename;
    SQLite3Connection2.Params.Add('foreign_keys=1');

  if not FileExists(SQLite3Connection2.DatabaseName) then
    begin
      ShowMessage('Datenbank-Datei KategParameter "LAGERB.db3" ist nicht vorhanden');
      exit;
    end
    else
      SQLite3Connection2.Connected := True;
      SQLTransaction2.Active := True;
      tbLagerB.Open;
  end;
  tbLagerB.First;

  Spaltenbreite();
end;

procedure TfrmMainForm.tbLagerAAfterPost(DataSet: TDataSet);
begin
  SQLTransaction1.Commit;
end;

procedure TfrmMainForm.tbLagerBCalcFields(DataSet: TDataSet);
begin
  tbLagerBG_Preis.Value:=tbLagerBBestand.Value * tbLagerBE_Preis.Value;
end;

procedure TfrmMainForm.tbLagerCalcFields(DataSet: TDataSet);
begin
  tbLagerAG_Preis.Value:=tbLagerABestand.Value * tbLagerAE_Preis.Value;
end;

procedure TfrmMainForm.Spaltenbreite();
begin

  DBGridA.Columns.ColumnByFieldname('ID').Width:=35;
  DBGridA.Columns.ColumnByFieldname('Artikel_Nr').Width:=150;
  DBGridA.Columns.ColumnByFieldname('Hersteller_Nr').Width:=150;
  DBGridA.Columns.ColumnByFieldname('Hersteller').Width:=80;
  DBGridA.Columns.ColumnByFieldname('Bezeichnung').Width:=250;
  DBGridA.Columns.ColumnByFieldname('Warengruppe').Width:=95;
  DBGridA.Columns.ColumnByFieldname('Bestand').Width:=55;
  DBGridA.Columns.ColumnByFieldname('Lagerort').Width:=85;
  DBGridA.Columns.ColumnByFieldname('E_Preis').Width:=55;
  DBGridA.Columns.ColumnByFieldname('G_Preis').Width:=75;

  DBGridB.Columns.ColumnByFieldname('ID').Width:=35;
  DBGridB.Columns.ColumnByFieldname('Artikel_Nr').Width:=150;
  DBGridB.Columns.ColumnByFieldname('Hersteller_Nr').Width:=150;
  DBGridB.Columns.ColumnByFieldname('Hersteller').Width:=80;
  DBGridB.Columns.ColumnByFieldname('Bezeichnung').Width:=250;
  DBGridB.Columns.ColumnByFieldname('Warengruppe').Width:=95;
  DBGridB.Columns.ColumnByFieldname('Bestand').Width:=55;
  DBGridB.Columns.ColumnByFieldname('Lagerort').Width:=85;
  DBGridB.Columns.ColumnByFieldname('E_Preis').Width:=55;
  DBGridB.Columns.ColumnByFieldname('G_Preis').Width:=75;

end;

end.

